# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`rsyslog`](#rsyslog): Manage the Rsyslog daemon package, service, and
configuration.
* [`rsyslog::base`](#rsyslog--base): This class manages the base installation for rsyslog
* [`rsyslog::config`](#rsyslog--config): Manage the configuration parameters for rsyslog.
This class can be called explicitly or through the use of
hieradata.
* [`rsyslog::config::actions`](#rsyslog--config--actions)
* [`rsyslog::config::custom`](#rsyslog--config--custom)
* [`rsyslog::config::expression_filters`](#rsyslog--config--expression_filters)
* [`rsyslog::config::global`](#rsyslog--config--global)
* [`rsyslog::config::inputs`](#rsyslog--config--inputs)
* [`rsyslog::config::legacy`](#rsyslog--config--legacy)
* [`rsyslog::config::lookup_tables`](#rsyslog--config--lookup_tables)
* [`rsyslog::config::main_queue`](#rsyslog--config--main_queue)
* [`rsyslog::config::modules`](#rsyslog--config--modules)
* [`rsyslog::config::parsers`](#rsyslog--config--parsers)
* [`rsyslog::config::property_filters`](#rsyslog--config--property_filters)
* [`rsyslog::config::rulesets`](#rsyslog--config--rulesets)
* [`rsyslog::config::templates`](#rsyslog--config--templates)

### Defined types

* [`rsyslog::component::action`](#rsyslog--component--action)
* [`rsyslog::component::custom_config`](#rsyslog--component--custom_config): This is a catch-all definition for use in edge cases where some code needs inserting somewhere in rsyslog.d according to priority but cannot 
* [`rsyslog::component::expression_filter`](#rsyslog--component--expression_filter)
* [`rsyslog::component::global_config`](#rsyslog--component--global_config)
* [`rsyslog::component::input`](#rsyslog--component--input)
* [`rsyslog::component::legacy_config`](#rsyslog--component--legacy_config)
* [`rsyslog::component::lookup_table`](#rsyslog--component--lookup_table)
* [`rsyslog::component::main_queue`](#rsyslog--component--main_queue)
* [`rsyslog::component::module`](#rsyslog--component--module)
* [`rsyslog::component::parser`](#rsyslog--component--parser)
* [`rsyslog::component::property_filter`](#rsyslog--component--property_filter)
* [`rsyslog::component::ruleset`](#rsyslog--component--ruleset)
* [`rsyslog::component::template`](#rsyslog--component--template)
* [`rsyslog::generate_concat`](#rsyslog--generate_concat)

### Data types

* [`Rsyslog::Actions`](#Rsyslog--Actions): Struct data type alias for Rsyslog Actions
* [`Rsyslog::Actions::Outputs::Omamqp1`](#Rsyslog--Actions--Outputs--Omamqp1)
* [`Rsyslog::Actions::Outputs::Omelasticsearch`](#Rsyslog--Actions--Outputs--Omelasticsearch)
* [`Rsyslog::Actions::Outputs::Omfile`](#Rsyslog--Actions--Outputs--Omfile)
* [`Rsyslog::Actions::Outputs::Omfwd`](#Rsyslog--Actions--Outputs--Omfwd)
* [`Rsyslog::Actions::Outputs::Omhiredis`](#Rsyslog--Actions--Outputs--Omhiredis)
* [`Rsyslog::Actions::Outputs::Omhttpfs`](#Rsyslog--Actions--Outputs--Omhttpfs)
* [`Rsyslog::Actions::Outputs::Omjournal`](#Rsyslog--Actions--Outputs--Omjournal): Struct data type for the Rsyslog JournalD module's Action options
* [`Rsyslog::Actions::Outputs::Omkafka`](#Rsyslog--Actions--Outputs--Omkafka): Struct data type for the Rsyslog Kafka module's Action options
* [`Rsyslog::Actions::Outputs::Omlibdbi`](#Rsyslog--Actions--Outputs--Omlibdbi): Struct data type for the Rsyslog libdbi module's Action options
* [`Rsyslog::Actions::Outputs::Ommail`](#Rsyslog--Actions--Outputs--Ommail): Struct data type for the Rsyslog E-Mail module's Action options
* [`Rsyslog::Actions::Outputs::Ommongodb`](#Rsyslog--Actions--Outputs--Ommongodb): Struct data type for the Rsyslog MongoDB output module's Action options
* [`Rsyslog::Actions::Outputs::Ommysql`](#Rsyslog--Actions--Outputs--Ommysql): Struct data type alias for MySQL Rsyslog output module.
* [`Rsyslog::Actions::Outputs::Ompgsql`](#Rsyslog--Actions--Outputs--Ompgsql): Struct data type for the Rsyslog PostgreSQL module's Action options  Not allowing the serverport, uid, or pwd rsyslog options as they are ide
* [`Rsyslog::Actions::Outputs::Ompipe`](#Rsyslog--Actions--Outputs--Ompipe): Struct data type for the Rsyslog Pipe module's Action options
* [`Rsyslog::Actions::Outputs::Omprog`](#Rsyslog--Actions--Outputs--Omprog): Struct data type for the Rsyslog Program module's Action options
* [`Rsyslog::Actions::Outputs::Omrelp`](#Rsyslog--Actions--Outputs--Omrelp): Struct data type for the Rsyslog RELP module's Action options
* [`Rsyslog::Actions::Outputs::Omsnmp`](#Rsyslog--Actions--Outputs--Omsnmp): Struct data type for the Rsyslog SNMP module's Action options
* [`Rsyslog::Actions::Outputs::Omudpspoof`](#Rsyslog--Actions--Outputs--Omudpspoof): Struct data type for the Rsyslog UDP Spoof module's Action options
* [`Rsyslog::Actions::Outputs::Omusrmsg`](#Rsyslog--Actions--Outputs--Omusrmsg): Struct data type for the Rsyslog User MSG module's Action Parameters.
* [`Rsyslog::Actions::Parameters`](#Rsyslog--Actions--Parameters): Struct data type for general Rsyslog Action parameters
* [`Rsyslog::Inputs::Imbatchreports`](#Rsyslog--Inputs--Imbatchreports): Data type for Rsyslog Input module parameters for batch report inputs.
* [`Rsyslog::Inputs::Imfile`](#Rsyslog--Inputs--Imfile): Data type for Rsyslog Input module input parameters for file inputs.
* [`Rsyslog::Inputs::Imgssapi`](#Rsyslog--Inputs--Imgssapi): Data type for Rsyslog Input module input parameters for gssapi.
* [`Rsyslog::Inputs::Imkafka`](#Rsyslog--Inputs--Imkafka): Data type for Rsyslog Input module input parameters for Apache Kafka.
* [`Rsyslog::Inputs::Improg`](#Rsyslog--Inputs--Improg): Data type for Rsyslog Input module input parameters for Program input
* [`Rsyslog::Inputs::Imptcp`](#Rsyslog--Inputs--Imptcp): Data type for Rsyslog Plain TCP input module
* [`Rsyslog::Inputs::Imrelp`](#Rsyslog--Inputs--Imrelp): Data type for Rsyslog Plain TCP input module
* [`Rsyslog::Inputs::Imtcp`](#Rsyslog--Inputs--Imtcp): Data type for Rsyslog TCP input module
* [`Rsyslog::Inputs::Imtuxedoulog`](#Rsyslog--Inputs--Imtuxedoulog): Data for Rsyslog Input Tuxedo ULOG module
* [`Rsyslog::Inputs::Imudp`](#Rsyslog--Inputs--Imudp): Data type for Rsyslog UDP input module
* [`Rsyslog::Inputs::Imuxsock`](#Rsyslog--Inputs--Imuxsock): Data type for Rsyslog Unix Socket input module
* [`Rsyslog::Modules::Input`](#Rsyslog--Modules--Input)
* [`Rsyslog::Modules::Inputs::Imdocker`](#Rsyslog--Modules--Inputs--Imdocker): Data type for Rsyslog module parameters for imdocker
* [`Rsyslog::Modules::Inputs::Imfile`](#Rsyslog--Modules--Inputs--Imfile): Data type for Rsyslog Input module parameters for file inputs.
* [`Rsyslog::Modules::Inputs::Imjournal`](#Rsyslog--Modules--Inputs--Imjournal): Rsyslog imjournal Module parameter data type
* [`Rsyslog::Modules::Message`](#Rsyslog--Modules--Message)
* [`Rsyslog::Modules::Output`](#Rsyslog--Modules--Output)
* [`Rsyslog::Modules::Parser`](#Rsyslog--Modules--Parser)
* [`Rsyslog::Modules::String`](#Rsyslog--Modules--String)
* [`Rsyslog::PropertyOperator`](#Rsyslog--PropertyOperator): Enumerable custom type for rsyslog property operators
* [`Rsyslog::Queue::Parameters`](#Rsyslog--Queue--Parameters)
* [`Rsyslog::Syslog::Severity`](#Rsyslog--Syslog--Severity): Syslog severity data type

## Classes

### <a name="rsyslog"></a>`rsyslog`

Manage the Rsyslog daemon package, service, and
configuration.

#### Examples

##### using class

```puppet
class { 'rsyslog':
  manage_service => true,
}
```

##### using hieradata

```puppet
# Manifest
include rsyslog
include rsyslog::config

# Hieradata
---
rsyslog::confdir: /etc/rsyslog.d
rsyslog::package_name: rsyslog
rsysog::config::global_config:
  workDirectory:
    value: '/var/spool/rsyslog'
```

#### Parameters

The following parameters are available in the `rsyslog` class:

* [`confdir`](#-rsyslog--confdir)
* [`package_name`](#-rsyslog--package_name)
* [`package_version`](#-rsyslog--package_version)
* [`config_file`](#-rsyslog--config_file)
* [`feature_packages`](#-rsyslog--feature_packages)
* [`module_load_priority`](#-rsyslog--module_load_priority)
* [`service_name`](#-rsyslog--service_name)
* [`service_status`](#-rsyslog--service_status)
* [`service_enabled`](#-rsyslog--service_enabled)
* [`override_default_config`](#-rsyslog--override_default_config)
* [`manage_package`](#-rsyslog--manage_package)
* [`use_upstream_repo`](#-rsyslog--use_upstream_repo)
* [`manage_confdir`](#-rsyslog--manage_confdir)
* [`manage_service`](#-rsyslog--manage_service)
* [`external_service`](#-rsyslog--external_service)
* [`purge_config_files`](#-rsyslog--purge_config_files)
* [`global_config_priority`](#-rsyslog--global_config_priority)
* [`legacy_config_priority`](#-rsyslog--legacy_config_priority)
* [`template_priority`](#-rsyslog--template_priority)
* [`action_priority`](#-rsyslog--action_priority)
* [`input_priority`](#-rsyslog--input_priority)
* [`custom_priority`](#-rsyslog--custom_priority)
* [`main_queue_priority`](#-rsyslog--main_queue_priority)
* [`lookup_table_priority`](#-rsyslog--lookup_table_priority)
* [`parser_priorty`](#-rsyslog--parser_priorty)
* [`ruleset_priority`](#-rsyslog--ruleset_priority)
* [`filter_priority`](#-rsyslog--filter_priority)
* [`target_file`](#-rsyslog--target_file)
* [`conf_permissions`](#-rsyslog--conf_permissions)
* [`confdir_permissions`](#-rsyslog--confdir_permissions)
* [`global_conf_perms`](#-rsyslog--global_conf_perms)
* [`parser_priority`](#-rsyslog--parser_priority)

##### <a name="-rsyslog--confdir"></a>`confdir`

Data type: `String`

The rsyslog configuration directory.

##### <a name="-rsyslog--package_name"></a>`package_name`

Data type: `String`

The name of the rsyslog package to install.

##### <a name="-rsyslog--package_version"></a>`package_version`

Data type: `String`

The version of rsyslog to install.

##### <a name="-rsyslog--config_file"></a>`config_file`

Data type: `String`

The global rsyslog configuration file.

##### <a name="-rsyslog--feature_packages"></a>`feature_packages`

Data type: `Array`

List of additional rsyslog packages to install.

##### <a name="-rsyslog--module_load_priority"></a>`module_load_priority`

Data type: `Integer`

Order the loading of rsyslog modules relative to other configuration.

##### <a name="-rsyslog--service_name"></a>`service_name`

Data type: `String`

Name of the SystemD, Upstart, or SysVInit service.

##### <a name="-rsyslog--service_status"></a>`service_status`

Data type: `String`

State desired for the rsyslog service.

##### <a name="-rsyslog--service_enabled"></a>`service_enabled`

Data type: `Boolean`

Is the service enabled or not.

##### <a name="-rsyslog--override_default_config"></a>`override_default_config`

Data type: `Boolean`

Override the default rsyslog.conf file.

##### <a name="-rsyslog--manage_package"></a>`manage_package`

Data type: `Boolean`

Toggle the managing of the rsyslog package.

##### <a name="-rsyslog--use_upstream_repo"></a>`use_upstream_repo`

Data type: `Boolean`

Toggle using the upstream Adiscon Rsyslog repository.

##### <a name="-rsyslog--manage_confdir"></a>`manage_confdir`

Data type: `Boolean`

Toggle management of the Rsyslog configuration directory.

##### <a name="-rsyslog--manage_service"></a>`manage_service`

Data type: `Boolean`

Toggle management of the rsyslog service.

##### <a name="-rsyslog--external_service"></a>`external_service`

Data type: `Boolean`

Toggle if the service is external to where rsyslog is being run.
I.E. a service that starts a docker container running rsyslog.

##### <a name="-rsyslog--purge_config_files"></a>`purge_config_files`

Data type: `Boolean`

Toggle purging of unmanaged configuration files.

##### <a name="-rsyslog--global_config_priority"></a>`global_config_priority`

Data type: `Integer`

Set the global ordering of global configuration parameters in rsyslog.

##### <a name="-rsyslog--legacy_config_priority"></a>`legacy_config_priority`

Data type: `Integer`

Set the global ordering of legacy configuration parameters in rsyslog.

##### <a name="-rsyslog--template_priority"></a>`template_priority`

Data type: `Integer`

Set the global ordering of template configuration in rsyslog.

##### <a name="-rsyslog--action_priority"></a>`action_priority`

Data type: `Integer`

Set the global ordering of action configuration in rsyslog.

##### <a name="-rsyslog--input_priority"></a>`input_priority`

Data type: `Integer`

Set the global ordering of input configuration in rsyslog.

##### <a name="-rsyslog--custom_priority"></a>`custom_priority`

Data type: `Integer`

Set the global ordering of custom configuration in rsyslog.

##### <a name="-rsyslog--main_queue_priority"></a>`main_queue_priority`

Data type: `Integer`

Set the global ordering of main queue configuration in rsyslog.

##### <a name="-rsyslog--lookup_table_priority"></a>`lookup_table_priority`

Data type: `Integer`

Set the global ordering of lookup table configuration in rsyslog.

##### <a name="-rsyslog--parser_priorty"></a>`parser_priorty`

Set the global ordering of parser configuration in rsyslog.

##### <a name="-rsyslog--ruleset_priority"></a>`ruleset_priority`

Data type: `Integer`

Set the global ordering of rulesets configuration in rsyslog.

##### <a name="-rsyslog--filter_priority"></a>`filter_priority`

Data type: `Integer`

Set the global ordering of filter configuration in rsyslog.

##### <a name="-rsyslog--target_file"></a>`target_file`

Data type: `String`

Target file to insert configuration into.

##### <a name="-rsyslog--conf_permissions"></a>`conf_permissions`

Data type: `Stdlib::Filemode`

Set the file mode for the generated configuration files.

Default value: `'0644'`

##### <a name="-rsyslog--confdir_permissions"></a>`confdir_permissions`

Data type: `Stdlib::Filemode`

Set the file mode for the rsyslog.d configuration directory.

Default value: `'0755'`

##### <a name="-rsyslog--global_conf_perms"></a>`global_conf_perms`

Data type: `Stdlib::Filemode`

Set the file mode for the /etc/rsyslog.conf

Default value: `$conf_permissions`

##### <a name="-rsyslog--parser_priority"></a>`parser_priority`

Data type: `Integer`



### <a name="rsyslog--base"></a>`rsyslog::base`

This class manages the base installation for rsyslog

### <a name="rsyslog--config"></a>`rsyslog::config`

Manage the configuration parameters for rsyslog.
This class can be called explicitly or through the use of
hieradata.

#### Examples

##### using class

```puppet
class { 'rsyslog::config':
  global_config      => {
    'workDirectory'  => {
      'value'        => '/var/spool/rsyslog',
    },
    'maxMessageSize' => {
      'value'        => '64k'
    }
  },
  actions            => {
    'all_logs'       => {
      'type'         => 'omfile',
      'facility'     => '*.*;auth,authpriv.none',
      'config'       => {
        'dynaFile'   => 'remoteSyslog',
        'specifics'  => '/var/log/test',
      },
    },
  },
}
```

##### using hieradata

```puppet
# Include class
include rsyslog::config

# Hieradata
---
rsyslog::config::global_config:
  workDirectory:
    value: '/var/spool/rsyslog'
  maxMessageSize:
    value: '64k'
rsyslog::config::actions:
  all_logs:
    type: omfile
    factiliy: "*.*;auth,authpriv.none"
    config:
      dynaFile: remoteSyslog
      specifics: '/var/log/test'
```

#### Parameters

The following parameters are available in the `rsyslog::config` class:

* [`global_config`](#-rsyslog--config--global_config)
* [`legacy_config`](#-rsyslog--config--legacy_config)
* [`templates`](#-rsyslog--config--templates)
* [`actions`](#-rsyslog--config--actions)
* [`inputs`](#-rsyslog--config--inputs)
* [`custom_config`](#-rsyslog--config--custom_config)
* [`main_queue_opts`](#-rsyslog--config--main_queue_opts)
* [`modules`](#-rsyslog--config--modules)
* [`lookup_tables`](#-rsyslog--config--lookup_tables)
* [`parsers`](#-rsyslog--config--parsers)
* [`rulesets`](#-rsyslog--config--rulesets)
* [`property_filters`](#-rsyslog--config--property_filters)
* [`expression_filters`](#-rsyslog--config--expression_filters)

##### <a name="-rsyslog--config--global_config"></a>`global_config`

Data type: `Hash`

Hash of global configuration options. Supports both Rainerscript and Legacy
configuration formats depending on the configuration option.
* :name (String) [undef] Name of the global configuration option to set.
  * :priority (Integer) [10] Sets where in the config the option will be placed in the target file.
  * :target (String) [50_rsyslog.conf] File to place the conf
  * :confdir (String) [/etc/rsyslog.d] Directory where the configuration file exists.
  * :value (String) [] Value of the configuration item
  * :config (Hash) [{}] Hash of configuration data for the option. Contents
  dependent on the configuration option.
  * :type (Enum['rainerscript', 'legacy']) [rainerscript] configuration format to use.
  * :format (String) ['<%= $content %>'] The content format. Defaults to epp template code.

Default value: `{}`

##### <a name="-rsyslog--config--legacy_config"></a>`legacy_config`

Data type: `Hash`

Hash of rsyslog configuration in the legacy format.
* :name (String) [undef] Na,e of the legacy configuration option.
  * :priority (Integer) [10] Sets where in the config the option will be placed in the target file.
  * :target (String) [50_rsyslog.conf] File to place the conf
  * :value (String) [] Value of the configuration item
  * :confdir (String) [/etc/rsyslog.d] The configuration directory where config file exists.
  * :key (String) [legacy_key] The rsyslog legacy configuration key name
  * :type (String) [sysklogd] The type of legacy configuration it is.
  * :format (String) ['<%= $content %>'] The content format. Defaults to epp template code.

Default value: `{}`

##### <a name="-rsyslog--config--templates"></a>`templates`

Data type: `Hash`

Hash of rsyslog templates.
* :name (String) [undef] Name of the global configuration option to set.
  * :priority (Integer) [10] Sets where in the config the option will be placed in the target file.
  * :target (String) [50_rsyslog.conf] File to place the conf
  * :confdir (String) [/etc/rsyslog.d] Directory where the configuration file exists.
  * :type (Enum['string', 'list', 'subtree', 'plugin']) [undef] Rsyslog template type.
  * :list_descriptions (Array) [[]] An array of hashes representing list
  template constants and properties
  * :string (String) [''] String value for a String template.
  * :subtree (String) [''] String representation of the subtree value.
  * :plugin (String) [''] Name of the plugin the template will use.
  * :options (Hash) [{}] Hash of additional template options.
  * :format (String) ['<%= $content %>'] The content format. Defaults to epp template code.

Default value: `{}`

##### <a name="-rsyslog--config--actions"></a>`actions`

Data type: `Hash`

Hash of rsyslog actions.
* :name (String) [undef] Name of the global configuration option to set.
  * :priority (Integer) [10] Sets where in the config the option will be placed in the target file.
  * :target (String) [50_rsyslog.conf] File to place the conf
  * :confdir (String) [/etc/rsyslog.d] Directory where the configuration file exists.
  * :type (String) [undef] Type of output module the action will use.
  * :config (Optional[Hash]) [undef] A hash of output module specific configuration options.
  * :facility (String) ['default'] The syslog facility to use when outputting this action.
  * :format (String) ['<%= $content %>'] The content format. Defaults to epp template code.

Default value: `{}`

##### <a name="-rsyslog--config--inputs"></a>`inputs`

Data type: `Hash`

Hash of rsyslog input plugins to use.
* :name (String) [undef] Name of the global configuration option to set.
  * :priority (Integer) [10] Sets where in the config the option will be placed in the target file.
  * :target (String) [50_rsyslog.conf] File to place the conf
  * :confdir (String) [/etc/rsyslog.d] Directory where the configuration file exists.
  * :type (String) [undef] The name of the input module to use.
  * :config (Optional[Hash]) [undef] Hash of input module specific
  configuration settings. Depends on value of type
  * :format (String) ['<%= $content %>'] The content format. Defaults to epp template code.

Default value: `{}`

##### <a name="-rsyslog--config--custom_config"></a>`custom_config`

Data type: `Hash`

Hash of custom raw configuration to place in the rsyslog config file.
* :name (String) [undef] Name of the global configuration option to set.
  * :priority (Integer) [10] Sets where in the config the option will be placed in the target file.
  * :target (String) [50_rsyslog.conf] File to place the conf
  * :confdir (String) [/etc/rsyslog.d] Directory where the configuration file exists.
  * :content (String) [undef] The single/multi-line string representing the config.

Default value: `{}`

##### <a name="-rsyslog--config--main_queue_opts"></a>`main_queue_opts`

Data type: `Hash`



Default value: `{}`

##### <a name="-rsyslog--config--modules"></a>`modules`

Data type: `Hash`



Default value: `{}`

##### <a name="-rsyslog--config--lookup_tables"></a>`lookup_tables`

Data type: `Hash`



Default value: `{}`

##### <a name="-rsyslog--config--parsers"></a>`parsers`

Data type: `Hash`



Default value: `{}`

##### <a name="-rsyslog--config--rulesets"></a>`rulesets`

Data type: `Hash`



Default value: `{}`

##### <a name="-rsyslog--config--property_filters"></a>`property_filters`

Data type: `Hash`



Default value: `{}`

##### <a name="-rsyslog--config--expression_filters"></a>`expression_filters`

Data type: `Hash`



Default value: `{}`

### <a name="rsyslog--config--actions"></a>`rsyslog::config::actions`

The rsyslog::config::actions class.

### <a name="rsyslog--config--custom"></a>`rsyslog::config::custom`

The rsyslog::config::custom class.

### <a name="rsyslog--config--expression_filters"></a>`rsyslog::config::expression_filters`

The rsyslog::config::expression_filters class.

### <a name="rsyslog--config--global"></a>`rsyslog::config::global`

The rsyslog::config::global class.

### <a name="rsyslog--config--inputs"></a>`rsyslog::config::inputs`

The rsyslog::config::inputs class.

### <a name="rsyslog--config--legacy"></a>`rsyslog::config::legacy`

The rsyslog::config::legacy class.

### <a name="rsyslog--config--lookup_tables"></a>`rsyslog::config::lookup_tables`

The rsyslog::config::lookup_tables class.

### <a name="rsyslog--config--main_queue"></a>`rsyslog::config::main_queue`

The rsyslog::config::main_queue class.

### <a name="rsyslog--config--modules"></a>`rsyslog::config::modules`

The rsyslog::config::modules class.

### <a name="rsyslog--config--parsers"></a>`rsyslog::config::parsers`

The rsyslog::config::parsers class.

### <a name="rsyslog--config--property_filters"></a>`rsyslog::config::property_filters`

The rsyslog::config::property_filters class.

### <a name="rsyslog--config--rulesets"></a>`rsyslog::config::rulesets`

The rsyslog::config::rulesets class.

### <a name="rsyslog--config--templates"></a>`rsyslog::config::templates`

The rsyslog::config::templates class.

## Defined types

### <a name="rsyslog--component--action"></a>`rsyslog::component::action`

The rsyslog::component::action class.

#### Parameters

The following parameters are available in the `rsyslog::component::action` defined type:

* [`priority`](#-rsyslog--component--action--priority)
* [`target`](#-rsyslog--component--action--target)
* [`confdir`](#-rsyslog--component--action--confdir)
* [`type`](#-rsyslog--component--action--type)
* [`config`](#-rsyslog--component--action--config)
* [`facility`](#-rsyslog--component--action--facility)
* [`format`](#-rsyslog--component--action--format)

##### <a name="-rsyslog--component--action--priority"></a>`priority`

Data type: `Integer`



##### <a name="-rsyslog--component--action--target"></a>`target`

Data type: `String`



##### <a name="-rsyslog--component--action--confdir"></a>`confdir`

Data type: `String`



##### <a name="-rsyslog--component--action--type"></a>`type`

Data type: `String`



##### <a name="-rsyslog--component--action--config"></a>`config`

Data type: `Hash`



Default value: `{}`

##### <a name="-rsyslog--component--action--facility"></a>`facility`

Data type: `String[1]`



Default value: `'default'`

##### <a name="-rsyslog--component--action--format"></a>`format`

Data type: `String[1]`



Default value: `'<%= $content %>'`

### <a name="rsyslog--component--custom_config"></a>`rsyslog::component::custom_config`

This is a catch-all definition for use in edge cases where some code needs
inserting somewhere in rsyslog.d according to priority but cannot be modelled
with any of the shipped models.

#### Parameters

The following parameters are available in the `rsyslog::component::custom_config` defined type:

* [`content`](#-rsyslog--component--custom_config--content)
* [`priority`](#-rsyslog--component--custom_config--priority)
* [`target`](#-rsyslog--component--custom_config--target)
* [`confdir`](#-rsyslog--component--custom_config--confdir)
* [`filename_part`](#-rsyslog--component--custom_config--filename_part)

##### <a name="-rsyslog--component--custom_config--content"></a>`content`

Data type: `String`



##### <a name="-rsyslog--component--custom_config--priority"></a>`priority`

Data type: `Integer`



Default value: `$rsyslog::custom_priority`

##### <a name="-rsyslog--component--custom_config--target"></a>`target`

Data type: `String`



Default value: `"${name}.conf"`

##### <a name="-rsyslog--component--custom_config--confdir"></a>`confdir`

Data type: `String`



Default value: `$rsyslog::confdir`

##### <a name="-rsyslog--component--custom_config--filename_part"></a>`filename_part`

Data type: `String`



Default value: `$name`

### <a name="rsyslog--component--expression_filter"></a>`rsyslog::component::expression_filter`

The rsyslog::component::expression_filter class.

#### Parameters

The following parameters are available in the `rsyslog::component::expression_filter` defined type:

* [`priority`](#-rsyslog--component--expression_filter--priority)
* [`target`](#-rsyslog--component--expression_filter--target)
* [`confdir`](#-rsyslog--component--expression_filter--confdir)
* [`conditionals`](#-rsyslog--component--expression_filter--conditionals)
* [`format`](#-rsyslog--component--expression_filter--format)

##### <a name="-rsyslog--component--expression_filter--priority"></a>`priority`

Data type: `Integer`



##### <a name="-rsyslog--component--expression_filter--target"></a>`target`

Data type: `String`



##### <a name="-rsyslog--component--expression_filter--confdir"></a>`confdir`

Data type: `String`



##### <a name="-rsyslog--component--expression_filter--conditionals"></a>`conditionals`

Data type: `Hash`



##### <a name="-rsyslog--component--expression_filter--format"></a>`format`

Data type: `String`



Default value: `'<%= $content %>'`

### <a name="rsyslog--component--global_config"></a>`rsyslog::component::global_config`

The rsyslog::component::global_config class.

#### Parameters

The following parameters are available in the `rsyslog::component::global_config` defined type:

* [`priority`](#-rsyslog--component--global_config--priority)
* [`target`](#-rsyslog--component--global_config--target)
* [`confdir`](#-rsyslog--component--global_config--confdir)
* [`value`](#-rsyslog--component--global_config--value)
* [`config`](#-rsyslog--component--global_config--config)
* [`type`](#-rsyslog--component--global_config--type)
* [`format`](#-rsyslog--component--global_config--format)

##### <a name="-rsyslog--component--global_config--priority"></a>`priority`

Data type: `Integer`



##### <a name="-rsyslog--component--global_config--target"></a>`target`

Data type: `String`



##### <a name="-rsyslog--component--global_config--confdir"></a>`confdir`

Data type: `String`



##### <a name="-rsyslog--component--global_config--value"></a>`value`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-rsyslog--component--global_config--config"></a>`config`

Data type: `Hash`



Default value: `{}`

##### <a name="-rsyslog--component--global_config--type"></a>`type`

Data type: `String[1]`



Default value: `'rainerscript'`

##### <a name="-rsyslog--component--global_config--format"></a>`format`

Data type: `String[1]`



Default value: `'<%= $content %>'`

### <a name="rsyslog--component--input"></a>`rsyslog::component::input`

The rsyslog::component::input class.

#### Parameters

The following parameters are available in the `rsyslog::component::input` defined type:

* [`priority`](#-rsyslog--component--input--priority)
* [`target`](#-rsyslog--component--input--target)
* [`confdir`](#-rsyslog--component--input--confdir)
* [`type`](#-rsyslog--component--input--type)
* [`config`](#-rsyslog--component--input--config)
* [`format`](#-rsyslog--component--input--format)

##### <a name="-rsyslog--component--input--priority"></a>`priority`

Data type: `Integer`



##### <a name="-rsyslog--component--input--target"></a>`target`

Data type: `String`



##### <a name="-rsyslog--component--input--confdir"></a>`confdir`

Data type: `String`



##### <a name="-rsyslog--component--input--type"></a>`type`

Data type: `String`



##### <a name="-rsyslog--component--input--config"></a>`config`

Data type: `Hash`



Default value: `{}`

##### <a name="-rsyslog--component--input--format"></a>`format`

Data type: `String[1]`



Default value: `'<%= $content %>'`

### <a name="rsyslog--component--legacy_config"></a>`rsyslog::component::legacy_config`

The rsyslog::component::legacy_config class.

#### Parameters

The following parameters are available in the `rsyslog::component::legacy_config` defined type:

* [`priority`](#-rsyslog--component--legacy_config--priority)
* [`target`](#-rsyslog--component--legacy_config--target)
* [`confdir`](#-rsyslog--component--legacy_config--confdir)
* [`value`](#-rsyslog--component--legacy_config--value)
* [`key`](#-rsyslog--component--legacy_config--key)
* [`type`](#-rsyslog--component--legacy_config--type)
* [`format`](#-rsyslog--component--legacy_config--format)

##### <a name="-rsyslog--component--legacy_config--priority"></a>`priority`

Data type: `Integer`



##### <a name="-rsyslog--component--legacy_config--target"></a>`target`

Data type: `String`



##### <a name="-rsyslog--component--legacy_config--confdir"></a>`confdir`

Data type: `String`



##### <a name="-rsyslog--component--legacy_config--value"></a>`value`

Data type: `String`



##### <a name="-rsyslog--component--legacy_config--key"></a>`key`

Data type: `String[1]`



Default value: `'legacy_key'`

##### <a name="-rsyslog--component--legacy_config--type"></a>`type`

Data type: `String[1]`



Default value: `'sysklogd'`

##### <a name="-rsyslog--component--legacy_config--format"></a>`format`

Data type: `String[1]`



Default value: `'<%= $content %>'`

### <a name="rsyslog--component--lookup_table"></a>`rsyslog::component::lookup_table`

The rsyslog::component::lookup_table class.

#### Parameters

The following parameters are available in the `rsyslog::component::lookup_table` defined type:

* [`priority`](#-rsyslog--component--lookup_table--priority)
* [`target`](#-rsyslog--component--lookup_table--target)
* [`confdir`](#-rsyslog--component--lookup_table--confdir)
* [`lookup_json`](#-rsyslog--component--lookup_table--lookup_json)
* [`lookup_file`](#-rsyslog--component--lookup_table--lookup_file)
* [`reload_on_hup`](#-rsyslog--component--lookup_table--reload_on_hup)
* [`rsyslog_in_docker`](#-rsyslog--component--lookup_table--rsyslog_in_docker)
* [`json_file`](#-rsyslog--component--lookup_table--json_file)
* [`format`](#-rsyslog--component--lookup_table--format)

##### <a name="-rsyslog--component--lookup_table--priority"></a>`priority`

Data type: `Integer`



##### <a name="-rsyslog--component--lookup_table--target"></a>`target`

Data type: `String`



##### <a name="-rsyslog--component--lookup_table--confdir"></a>`confdir`

Data type: `String`



##### <a name="-rsyslog--component--lookup_table--lookup_json"></a>`lookup_json`

Data type: `Hash`



##### <a name="-rsyslog--component--lookup_table--lookup_file"></a>`lookup_file`

Data type: `Stdlib::AbsolutePath`



##### <a name="-rsyslog--component--lookup_table--reload_on_hup"></a>`reload_on_hup`

Data type: `Boolean`



##### <a name="-rsyslog--component--lookup_table--rsyslog_in_docker"></a>`rsyslog_in_docker`

Data type: `Boolean`



Default value: `false`

##### <a name="-rsyslog--component--lookup_table--json_file"></a>`json_file`

Data type: `Optional[Stdlib::AbsolutePath]`



Default value: `undef`

##### <a name="-rsyslog--component--lookup_table--format"></a>`format`

Data type: `String[1]`



Default value: `'<%= $content %>'`

### <a name="rsyslog--component--main_queue"></a>`rsyslog::component::main_queue`

The rsyslog::component::main_queue class.

#### Parameters

The following parameters are available in the `rsyslog::component::main_queue` defined type:

* [`priority`](#-rsyslog--component--main_queue--priority)
* [`target`](#-rsyslog--component--main_queue--target)
* [`confdir`](#-rsyslog--component--main_queue--confdir)
* [`config`](#-rsyslog--component--main_queue--config)

##### <a name="-rsyslog--component--main_queue--priority"></a>`priority`

Data type: `Integer`



##### <a name="-rsyslog--component--main_queue--target"></a>`target`

Data type: `String`



##### <a name="-rsyslog--component--main_queue--confdir"></a>`confdir`

Data type: `String`



##### <a name="-rsyslog--component--main_queue--config"></a>`config`

Data type: `Hash`



### <a name="rsyslog--component--module"></a>`rsyslog::component::module`

The rsyslog::component::module class.

#### Parameters

The following parameters are available in the `rsyslog::component::module` defined type:

* [`priority`](#-rsyslog--component--module--priority)
* [`target`](#-rsyslog--component--module--target)
* [`confdir`](#-rsyslog--component--module--confdir)
* [`config`](#-rsyslog--component--module--config)
* [`type`](#-rsyslog--component--module--type)
* [`format`](#-rsyslog--component--module--format)

##### <a name="-rsyslog--component--module--priority"></a>`priority`

Data type: `Integer`



##### <a name="-rsyslog--component--module--target"></a>`target`

Data type: `String`



##### <a name="-rsyslog--component--module--confdir"></a>`confdir`

Data type: `String`



##### <a name="-rsyslog--component--module--config"></a>`config`

Data type: `Hash`



Default value: `{}`

##### <a name="-rsyslog--component--module--type"></a>`type`

Data type: `String[1]`



Default value: `'external'`

##### <a name="-rsyslog--component--module--format"></a>`format`

Data type: `String[1]`



Default value: `'<%= $content %>'`

### <a name="rsyslog--component--parser"></a>`rsyslog::component::parser`

The rsyslog::component::parser class.

#### Parameters

The following parameters are available in the `rsyslog::component::parser` defined type:

* [`priority`](#-rsyslog--component--parser--priority)
* [`target`](#-rsyslog--component--parser--target)
* [`confdir`](#-rsyslog--component--parser--confdir)
* [`type`](#-rsyslog--component--parser--type)
* [`config`](#-rsyslog--component--parser--config)
* [`format`](#-rsyslog--component--parser--format)

##### <a name="-rsyslog--component--parser--priority"></a>`priority`

Data type: `Integer`



##### <a name="-rsyslog--component--parser--target"></a>`target`

Data type: `String`



##### <a name="-rsyslog--component--parser--confdir"></a>`confdir`

Data type: `String`



##### <a name="-rsyslog--component--parser--type"></a>`type`

Data type: `String`



##### <a name="-rsyslog--component--parser--config"></a>`config`

Data type: `Hash`



Default value: `{}`

##### <a name="-rsyslog--component--parser--format"></a>`format`

Data type: `String[1]`



Default value: `'<%= $content %>'`

### <a name="rsyslog--component--property_filter"></a>`rsyslog::component::property_filter`

The rsyslog::component::property_filter class.

#### Parameters

The following parameters are available in the `rsyslog::component::property_filter` defined type:

* [`priority`](#-rsyslog--component--property_filter--priority)
* [`target`](#-rsyslog--component--property_filter--target)
* [`confdir`](#-rsyslog--component--property_filter--confdir)
* [`property`](#-rsyslog--component--property_filter--property)
* [`operator`](#-rsyslog--component--property_filter--operator)
* [`value`](#-rsyslog--component--property_filter--value)
* [`tasks`](#-rsyslog--component--property_filter--tasks)
* [`format`](#-rsyslog--component--property_filter--format)

##### <a name="-rsyslog--component--property_filter--priority"></a>`priority`

Data type: `Integer`



##### <a name="-rsyslog--component--property_filter--target"></a>`target`

Data type: `String`



##### <a name="-rsyslog--component--property_filter--confdir"></a>`confdir`

Data type: `String`



##### <a name="-rsyslog--component--property_filter--property"></a>`property`

Data type: `String`



##### <a name="-rsyslog--component--property_filter--operator"></a>`operator`

Data type: `Rsyslog::PropertyOperator`



##### <a name="-rsyslog--component--property_filter--value"></a>`value`

Data type: `String`



##### <a name="-rsyslog--component--property_filter--tasks"></a>`tasks`

Data type: `Array`



Default value: `[]`

##### <a name="-rsyslog--component--property_filter--format"></a>`format`

Data type: `String`



Default value: `'<%= $content %>'`

### <a name="rsyslog--component--ruleset"></a>`rsyslog::component::ruleset`

The rsyslog::component::ruleset class.

#### Parameters

The following parameters are available in the `rsyslog::component::ruleset` defined type:

* [`priority`](#-rsyslog--component--ruleset--priority)
* [`target`](#-rsyslog--component--ruleset--target)
* [`confdir`](#-rsyslog--component--ruleset--confdir)
* [`rules`](#-rsyslog--component--ruleset--rules)
* [`stop`](#-rsyslog--component--ruleset--stop)
* [`parameters`](#-rsyslog--component--ruleset--parameters)
* [`format`](#-rsyslog--component--ruleset--format)

##### <a name="-rsyslog--component--ruleset--priority"></a>`priority`

Data type: `Integer`



##### <a name="-rsyslog--component--ruleset--target"></a>`target`

Data type: `String`



##### <a name="-rsyslog--component--ruleset--confdir"></a>`confdir`

Data type: `String`



##### <a name="-rsyslog--component--ruleset--rules"></a>`rules`

Data type: `Array`



Default value: `[]`

##### <a name="-rsyslog--component--ruleset--stop"></a>`stop`

Data type: `Boolean`



Default value: `false`

##### <a name="-rsyslog--component--ruleset--parameters"></a>`parameters`

Data type: `Hash`



Default value: `{}`

##### <a name="-rsyslog--component--ruleset--format"></a>`format`

Data type: `String[1]`



Default value: `'<%= $content %>'`

### <a name="rsyslog--component--template"></a>`rsyslog::component::template`

The rsyslog::component::template class.

#### Parameters

The following parameters are available in the `rsyslog::component::template` defined type:

* [`priority`](#-rsyslog--component--template--priority)
* [`target`](#-rsyslog--component--template--target)
* [`confdir`](#-rsyslog--component--template--confdir)
* [`type`](#-rsyslog--component--template--type)
* [`list_descriptions`](#-rsyslog--component--template--list_descriptions)
* [`string`](#-rsyslog--component--template--string)
* [`subtree`](#-rsyslog--component--template--subtree)
* [`plugin`](#-rsyslog--component--template--plugin)
* [`options`](#-rsyslog--component--template--options)
* [`format`](#-rsyslog--component--template--format)

##### <a name="-rsyslog--component--template--priority"></a>`priority`

Data type: `Integer`



##### <a name="-rsyslog--component--template--target"></a>`target`

Data type: `String`



##### <a name="-rsyslog--component--template--confdir"></a>`confdir`

Data type: `String`



##### <a name="-rsyslog--component--template--type"></a>`type`

Data type: `Enum['string', 'list', 'subtree', 'plugin']`



##### <a name="-rsyslog--component--template--list_descriptions"></a>`list_descriptions`

Data type: `Array`



Default value: `[]`

##### <a name="-rsyslog--component--template--string"></a>`string`

Data type: `String`



Default value: `''`

##### <a name="-rsyslog--component--template--subtree"></a>`subtree`

Data type: `String`



Default value: `''`

##### <a name="-rsyslog--component--template--plugin"></a>`plugin`

Data type: `String`



Default value: `''`

##### <a name="-rsyslog--component--template--options"></a>`options`

Data type: `Hash`



Default value: `{}`

##### <a name="-rsyslog--component--template--format"></a>`format`

Data type: `String[1]`



Default value: `'<%= $content %>'`

### <a name="rsyslog--generate_concat"></a>`rsyslog::generate_concat`

The rsyslog::generate_concat class.

#### Parameters

The following parameters are available in the `rsyslog::generate_concat` defined type:

* [`confdir`](#-rsyslog--generate_concat--confdir)
* [`target`](#-rsyslog--generate_concat--target)

##### <a name="-rsyslog--generate_concat--confdir"></a>`confdir`

Data type: `String`



##### <a name="-rsyslog--generate_concat--target"></a>`target`

Data type: `String`



## Data types

### <a name="Rsyslog--Actions"></a>`Rsyslog::Actions`

Struct data type alias for Rsyslog Actions

Alias of

```puppet
Array[Struct[{
    name          => String[1],
    type          => Rsyslog::Modules::Output,
    facility      => Optional[String[1]],
    action_params => Optional[Rsyslog::Actions::Parameters],
    queue_params  => Optional[Rsyslog::Queue::Parameters],
    output_params => Optional[Variant[
      Rsyslog::Actions::Outputs::Omamqp1,
      Rsyslog::Actions::Outputs::Omelasticsearch,
      Rsyslog::Actions::Outputs::Omfile,
      Rsyslog::Actions::Outputs::Omfwd,
      Rsyslog::Actions::Outputs::Omhiredis,
      Rsyslog::Actions::Outputs::Omhttpfs,
      Rsyslog::Actions::Outputs::Omjournal,
      Rsyslog::Actions::Outputs::Omkafka,
      Rsyslog::Actions::Outputs::Omlibdbi,
      Rsyslog::Actions::Outputs::Ommail,
      Rsyslog::Actions::Outputs::Ommongodb,
      Rsyslog::Actions::Outputs::Ommysql,
      Rsyslog::Actions::Outputs::Ompgsql,
      Rsyslog::Actions::Outputs::Ompipe,
      Rsyslog::Actions::Outputs::Omprog,
      Rsyslog::Actions::Outputs::Omrelp,
      Rsyslog::Actions::Outputs::Omsnmp,
      Rsyslog::Actions::Outputs::Omudpspoof,
      Rsyslog::Actions::Outputs::Omusrmsg,
    ]],
  }]]
```

### <a name="Rsyslog--Actions--Outputs--Omamqp1"></a>`Rsyslog::Actions::Outputs::Omamqp1`

The Rsyslog::Actions::Outputs::Omamqp1 data type.

Alias of

```puppet
Struct[{
  host           => String[1],
  target         => String[1],
  username       => Optional[String[1]],
  password       => Optional[String[1]],
  template       => Optional[String[1]],
  idletimeout    => Optional[Integer],
  reconnectdelay => Optional[Integer],
  maxretries     => Optional[Integer],
  disablesasl    => Optional[Integer],
}]
```

### <a name="Rsyslog--Actions--Outputs--Omelasticsearch"></a>`Rsyslog::Actions::Outputs::Omelasticsearch`

The Rsyslog::Actions::Outputs::Omelasticsearch data type.

Alias of

```puppet
Struct[{
  server               => Optional[Variant[Stdlib::Host, Array[Stdlib::Host]]],
  serverport           => Optional[Stdlib::Port],
  healthchecktimeout   => Optional[Integer],
  searchindex          => Optional[String[1]],
  dynsearchindex       => Optional[Enum['on', 'off']],
  searchtype           => Optional[String[1]],
  dynsearchtype        => Optional[Enum['on', 'off']],
  pipelinename         => Optional[String[1]],
  dynpipelinename      => Optional[Enum['on', 'off']],
  usehttps             => Optional[Enum['on', 'off']],
  timeout              => Optional[Pattern[/^([0-9]+)(ms|s|m)$/]],
  template             => Optional[String[1]],
  bulkmode             => Optional[Enum['on', 'off']],
  maxbytes             => Optional[Pattern[/^([0-9]+)[kKmMgGtT]$/]],
  parent               => Optional[String[1]],
  dynparent            => Optional[Enum['on', 'off']],
  uid                  => Optional[String[1]],
  pwd                  => Optional[String[1]],
  errorfile            => Optional[Stdlib::Absolutepath],
  'tls.cacert'         => Optional[Stdlib::Absolutepath],
  'tls.mycert'         => Optional[Stdlib::Absolutepath],
  'tls.myprivkey'      => Optional[Stdlib::Absolutepath],
  bulkid               => Optional[String[1]],
  dynbulkid            => Optional[Enum['on', 'off']],
  writeoperation       => Optional[Enum['index', 'create']],
  retryfailures        => Optional[Enum['on', 'off']],
  retryruleset         => Optional[String[1]],
  'ratelimit.interval' => Optional[Integer],
  'ratelimit.burst'    => Optional[Integer],
}]
```

### <a name="Rsyslog--Actions--Outputs--Omfile"></a>`Rsyslog::Actions::Outputs::Omfile`

The Rsyslog::Actions::Outputs::Omfile data type.

Alias of

```puppet
Struct[{
  file               => Optional[Stdlib::Absolutepath],
  dynafile           => Optional[String[1]],
  template           => Optional[String[1]],
  closetimeout       => Optional[Integer],
  dynafilecachesize  => Optional[Integer],
  ziplevel           => Optional[Integer],
  veryrobustzip      => Optional[Enum['on', 'off']],
  flushinterval      => Optional[Integer],
  asyncwriting       => Optional[Enum['on', 'off']],
  flushontxend       => Optional[Enum['on', 'off']],
  iobuffersize       => Optional[Pattern[/^([0-9]+)[kKmMgGtT]$/]],
  dirowner           => Optional[String[1]],
  dirownernum        => Optional[Integer],
  dirgroup           => Optional[String[1]],
  dirgroupnum        => Optional[Integer],
  fileowner          => Optional[String[1]],
  fileownernum       => Optional[Integer],
  filegroup          => Optional[String[1]],
  filegroupnum       => Optional[Integer],
  filecreatemode     => Optional[Pattern[/^(([0-7]{1,4})*)$/]],
  dircreatemode      => Optional[Pattern[/^(([0-7]{1,4})*)$/]],
  failonchownfailure => Optional[Enum['on', 'off']],
  createdirs         => Optional[Enum['on', 'off']],
  sync               => Optional[Enum['on', 'off']],
  'sig.provider'     => Optional[Enum['ksi_ls12']],
  'cry.provider'     => Optional[Enum['gcry']],
}]
```

### <a name="Rsyslog--Actions--Outputs--Omfwd"></a>`Rsyslog::Actions::Outputs::Omfwd`

The Rsyslog::Actions::Outputs::Omfwd data type.

Alias of

```puppet
Struct[{
  target                            => Optional[Stdlib::Host],
  port                              => Optional[Stdlib::Port],
  protocol                          => Optional[Enum['tcp', 'udp', 'ossl', 'gtls']],
  networknamespace                  => Optional[String[1]],
  address                           => Optional[Stdlib::IP::Address],
  ipfreebind                        => Optional[Integer[0, 2]],
  device                            => Optional[String[1]],
  tcp_framing                       => Optional[Enum['traditional', 'octet-counted']],
  tcp_framedelimiter                => Optional[Integer[0, 255]],
  ziplevel                          => Optional[Integer[0, 9]],
  'compression.mode'                => Optional[Enum['none', 'single', 'stream:always']],
  'compression.stream.flushontxend' => Optional[Enum['on', 'off']],
  rebindinterval                    => Optional[Integer],
  keepalive                         => Optional[Enum['on', 'off']],
  'keepalive.probes'                => Optional[Integer],
  'keepalive.interval'              => Optional[Integer],
  'keepalive.time'                  => Optional[Integer],
  streamdriver                      => Optional[Enum['tcp', 'ossl', 'gtls']],
  streamdrivermode                  => Optional[Integer],
  streamdriverauthmode              => Optional[String[1]],
  streamdriverpermittedpeers        => Optional[String[1]],
  resendlastmsgonreconnect          => Optional[Enum['on', 'off']],
  'udp.sendtoall'                   => Optional[Enum['on', 'off']],
  'udp.senddelay'                   => Optional[Integer],
  gnutlsprioritystring              => Optional[String[1]],
}]
```

### <a name="Rsyslog--Actions--Outputs--Omhiredis"></a>`Rsyslog::Actions::Outputs::Omhiredis`

The Rsyslog::Actions::Outputs::Omhiredis data type.

Alias of

```puppet
Struct[{
  server         => Optional[Stdlib::Host],
  serverport     => Optional[Stdlib::Port],
  serverpassword => Optional[String[1]],
  mode           => Optional[Enum['queue', 'publish', 'template']],
  template       => Optional[String[1]],
  key            => Optional[String[1]],
  userpush       => Optional[Enum['on', 'off']]
}]
```

### <a name="Rsyslog--Actions--Outputs--Omhttpfs"></a>`Rsyslog::Actions::Outputs::Omhttpfs`

The Rsyslog::Actions::Outputs::Omhttpfs data type.

Alias of

```puppet
Struct[{
  host      => Optional[Stdlib::Host],
  port      => Optional[Stdlib::Port],
  user      => Optional[String[1]],
  https     => Optional[Enum['on', 'off']],
  file      => String[1],
  isdynfile => Optional[Enum['on', 'off']],
  template  => Optional[String[1]]
}]
```

### <a name="Rsyslog--Actions--Outputs--Omjournal"></a>`Rsyslog::Actions::Outputs::Omjournal`

Struct data type for the Rsyslog JournalD module's Action options

Alias of

```puppet
Struct[{
  template => Optional[String[1]],
}]
```

### <a name="Rsyslog--Actions--Outputs--Omkafka"></a>`Rsyslog::Actions::Outputs::Omkafka`

Struct data type for the Rsyslog Kafka module's Action options

Alias of

```puppet
Struct[{
  broker                => Optional[String[1]],
  topic                 => String[1],
  key                   => Optional[String[1]],
  dynatopic             => Optional[Enum['on', 'off']],
  'dynatopic.cachesize' => Optional[Integer],
  'partitions.auto'     => Optional[Enum['on', 'off']],
  'partitions.number'   => Optional[Integer],
  'partitions.usefixed' => Optional[Integer],
  errorfile             => Optional[String[1]],
  confparam             => Optional[Array[String[1]]],
  topicconfparam        => Optional[Array[String[1]]],
  template              => Optional[String[1]],
  closetimeout          => Optional[Integer],
  resubmitonfailure     => Optional[Enum['on', 'off']],
  keepfailedmessages    => Optional[Enum['on', 'off']],
  failedmsgfile         => Optional[String[1]],
}]
```

### <a name="Rsyslog--Actions--Outputs--Omlibdbi"></a>`Rsyslog::Actions::Outputs::Omlibdbi`

Struct data type for the Rsyslog libdbi module's Action options

Alias of

```puppet
Struct[{
  driver   => Enum[
    'firebird',
    'ingres',
    'msql',
    'Oracle',
    'sqlite',
    'sqlite3',
    'freetds',
  ],
  server   => Stdlib::Host,
  uid      => String[1],
  pwd      => String[1],
  db       => String[1],
  template => Optional[String[1]],
}]
```

### <a name="Rsyslog--Actions--Outputs--Ommail"></a>`Rsyslog::Actions::Outputs::Ommail`

Struct data type for the Rsyslog E-Mail module's Action options

Alias of

```puppet
Struct[{
  server             => Stdlib::Host,
  port               => Stdlib::Port,
  mailfrom           => Pattern[/.+@.+\..+/],
  mailto             => Pattern[/.+@.+\..+/],
  'subject.template' => Optional[String[1]],
  'subject.text'     => Optional[String[1]],
  'body.enable'      => Optional[Enum['on', 'off']],
  template           => Optional[String[1]],
}]
```

### <a name="Rsyslog--Actions--Outputs--Ommongodb"></a>`Rsyslog::Actions::Outputs::Ommongodb`

Struct data type for the Rsyslog MongoDB output module's Action options

Alias of

```puppet
Struct[{
  uristr              => Optional[String[1]],
  ssl_cert            => Optional[Stdlib::Absolutepath],
  ssl_ca              => Optional[Stdlib::Absolutepath],
  db                  => Optional[String[1]],
  collection          => Optional[String[1]],
  allowed_error_codes => Optional[Array[String[1]]],
  template            => Optional[String[1]],
  server              => Optional[Stdlib::Host],
  serverported        => Optional[Stdlib::Port],
  uid                 => Optional[String[1]],
  pwd                 => Optional[String[1]],
}]
```

### <a name="Rsyslog--Actions--Outputs--Ommysql"></a>`Rsyslog::Actions::Outputs::Ommysql`

Struct data type alias for MySQL Rsyslog output module.

* **See also**
  * https://www.rsyslog.com/doc/v8-stable/configuration/modules/ommysql.html
  * Rsyslog MySQL output module

Alias of

```puppet
Struct[{
  server                => Stdlib::Host,
  socket                => Optional[Stdlib::Absolutepath],
  db                    => String[1],
  uid                   => String[1],
  pwd                   => String[1],
  serverport            => Optional[Stdlib::Port],
  'mysqlconfig.file'    => Optional[Stdlib::Absolutepath],
  'mysqlconfig.section' => Optional[String[1]],
  template              => Optional[String[1]],
}]
```

### <a name="Rsyslog--Actions--Outputs--Ompgsql"></a>`Rsyslog::Actions::Outputs::Ompgsql`

Struct data type for the Rsyslog PostgreSQL module's Action options

Not allowing the serverport, uid, or pwd rsyslog options as they are
identical to port, user, and pass respectively. The latter make more
sense to the general user and the former are redundant.

Alias of

```puppet
Struct[{
  server   => Stdlib::Host,
  port     => Optional[Stdlib::Port],
  db       => String[1],
  user     => Optional[String[1]],
  pass     => Optional[String[1]],
  template => Optional[String[1]],
}]
```

### <a name="Rsyslog--Actions--Outputs--Ompipe"></a>`Rsyslog::Actions::Outputs::Ompipe`

Struct data type for the Rsyslog Pipe module's Action options

Alias of

```puppet
Struct[{
  pipe => String[1],
}]
```

### <a name="Rsyslog--Actions--Outputs--Omprog"></a>`Rsyslog::Actions::Outputs::Omprog`

Struct data type for the Rsyslog Program module's Action options

Alias of

```puppet
Struct[{
  template              => Optional[String[1]],
  binary                => Stdlib::Absolutepath,
  confirmmessages       => Optional[Enum['on', 'off']],
  confirmtimeout        => Optional[Integer],
  reportfailures        => Optional[Enum['on', 'off']],
  usetransactions       => Optional[Enum['on', 'off']],
  begintransactionmark  => Optional[String[1]],
  committransactionmark => Optional[String[1]],
  output                => Optional[Stdlib::Absolutepath],
  filecreatemode        => Optional[Stdlib::Filemode],
  'hup.signal'          => Optional[Enum['HUP', 'USR1', 'USR2', 'INT', 'TERM']],
  signalonclose         => Optional[Enum['on', 'off']],
  closetimeout          => Optional[Integer],
  killunresponsive      => Optional[Enum['on', 'off']],
  forcesingleinstance   => Optional[Enum['on', 'off']],
}]
```

### <a name="Rsyslog--Actions--Outputs--Omrelp"></a>`Rsyslog::Actions::Outputs::Omrelp`

Struct data type for the Rsyslog RELP module's Action options

Alias of

```puppet
Struct[{
  target               => Variant[Stdlib::Fqdn, Stdlib::IP::Address],
  port                 => Optional[Stdlib::Port],
  template             => Optional[String[1]],
  timeout              => Optional[Integer],
  'conn.timeout'       => Optional[Integer],
  rebindinterval       => Optional[Integer],
  windowsize           => Optional[Integer],
  tls                  => Optional[Enum['on', 'off']],
  'tls.compression'    => Optional[Enum['on', 'off']],
  'tls.permittedpeer'  => Optional[Array[String[1]]],
  'tls.automode'       => Optional[Enum['fingerprint', 'name']],
  'tls.cacert'         => Optional[Stdlib::Absolutepath],
  'tls.mycert'         => Optional[Stdlib::Absolutepath],
  'tls.myprivkey'      => Optional[Stdlib::Absolutepath],
  'tls.prioritystring' => Optional[String[1]],
  localclientip        => Optional[Stdlib::IP::Address],
}]
```

### <a name="Rsyslog--Actions--Outputs--Omsnmp"></a>`Rsyslog::Actions::Outputs::Omsnmp`

Struct data type for the Rsyslog SNMP module's Action options

Alias of

```puppet
Struct[{
  server => Stdlib::Host,
  port   => Optional[Stdlib::Port],
  transport => Optional[String[1]],
  version   => Optional[Integer[0,1]],
  community => Optional[String[1]],
  trapoid   => Optional[String[1]],
  messageoid => Optional[String[1]],
  enterpriseoid => Optional[String[1]],
  specifictype  => Optional[Integer],
  traptype      => Optional[Integer[0,6]],
}]
```

### <a name="Rsyslog--Actions--Outputs--Omudpspoof"></a>`Rsyslog::Actions::Outputs::Omudpspoof`

Struct data type for the Rsyslog UDP Spoof module's Action options

Alias of

```puppet
Struct[{
  target             => Stdlib::Host,
  port               => Optional[Stdlib::Port],
  sourcetemplate     => Optional[String[1]],
  'sourceport.start' => Optional[Stdlib::Port],
  'sourceport.end'   => Optional[Stdlib::Port],
  mtu                => Optional[Integer],
  template           => Optional[String[1]],
}]
```

### <a name="Rsyslog--Actions--Outputs--Omusrmsg"></a>`Rsyslog::Actions::Outputs::Omusrmsg`

Struct data type for the Rsyslog User MSG module's Action Parameters.

Alias of

```puppet
Struct[{
  users    => String[1],
  template => Optional[String[1]],
}]
```

### <a name="Rsyslog--Actions--Parameters"></a>`Rsyslog::Actions::Parameters`

Struct data type for general Rsyslog Action parameters

* **See also**
  * https://www.rsyslog.com/doc/v8-stable/configuration/actions.html#general-action-parameters
  * Rsyslog General Action Parameters

Alias of

```puppet
Struct[{
  'action.writeallmarkmessages'            => Optional[Enum['on', 'off']],
  'action.execonlyeverynthtime'            => Optional[Integer],
  'action.execonlyeverynthtimeout'         => Optional[Integer],
  'action.errorfile'                       => Optional[Stdlib::Absolutepath],
  'action.execonlyonceeveryinterval'       => Optional[Integer],
  'action.execonlywhenpreviousissuspended' => Optional[Enum['on', 'off']],
  'action.repeatedmsgcontainsoriginalmsg'  => Optional[Enum['on', 'off']],
  'action.resumeretrycount'                => Optional[Integer],
  'action.resumeinterval'                  => Optional[Integer],
  'action.reportsuspension'                => Optional[Enum['on', 'off']],
  'action.reportsuspensioncontinuation'    => Optional[Enum['on', 'off']],
  'action.copymsg'                         => Optional[Enum['on', 'off']]
}]
```

### <a name="Rsyslog--Inputs--Imbatchreports"></a>`Rsyslog::Inputs::Imbatchreports`

Data type for Rsyslog Input module parameters for batch report inputs.

Alias of

```puppet
Struct[{
  reports           => String[1],
  tag               => String[1],
  facility          => Optional[Stdlib::Syslogfacility],
  severity          => Optional[Rsyslog::Syslog::Severity],
  deduplicatespaces => Optional[Enum['on', 'off']],
  delete            => Optional[String[1]],
  rename            => Optional[String[1]],
  programkey        => Optional[String[1]],
  timestampkey      => Optional[String[1]],
}]
```

### <a name="Rsyslog--Inputs--Imfile"></a>`Rsyslog::Inputs::Imfile`

Data type for Rsyslog Input module input parameters for file inputs.

Alias of

```puppet
Struct[{
  file                    => String[1],
  tag                     => String[1],
  facility                => Optional[Stdlib::Syslogfacility],
  severity                => Optional[Rsyslog::Syslog::Severity],
  persiststateinterval    => Optional[Integer],
  'startmsg.regex'        => Optional[String[1]],
  'endmsg.regex'          => Optional[String[1]],
  readtimeout             => Optional[Integer],
  readmode                => Optional[Integer[0, 2]],
  escapelf                => Optional[Enum['on', 'off']],
  maxlinesatonce          => Optional[Integer],
  maxsubmitatonce         => Optional[Integer],
  deletestateonfiledelete => Optional[Enum['on', 'off']],
  ruleset                 => Optional[String[1]],
  addmetadata             => Optional[Enum['on', 'off']],
  addceetag               => Optional[Enum['on', 'off']],
  reopenontruncate        => Optional[Enum['on', 'off']],
  trimlineoverbytes       => Optional[Integer],
  freshstarttail          => Optional[Enum['on', 'off']],
  discardtruncatedmsg     => Optional[Enum['on', 'off']],
  msgdiscardingerror      => Optional[Enum['on', 'off']],
  neeparse                => Optional[Enum['on', 'off']],
}]
```

### <a name="Rsyslog--Inputs--Imgssapi"></a>`Rsyslog::Inputs::Imgssapi`

Data type for Rsyslog Input module input parameters for gssapi.

Alias of

```puppet
Struct[{
  inputgssserverrun            => Optional[Stdlib::Port],
  inputgssserverservicename    => Optional[String[1]],
  inputgssserverpermitplaintcp => Optional[Enum['on', 'off']],
  inputgssservermaxsessions    => Optional[Integer],
  inputgssserverkeepalive      => Optional[Enum['on', 'off']],
  inputgsslistenportfilename   => Optional[Stdlib::Port],
}]
```

### <a name="Rsyslog--Inputs--Imkafka"></a>`Rsyslog::Inputs::Imkafka`

Data type for Rsyslog Input module input parameters for Apache Kafka.

Alias of

```puppet
Struct[{
  broker        => Optional[String[1]],
  topic         => String[1],
  confparam     => Optional[Array[String[1]]],
  consumergroup => Optional[String[1]],
  ruleset       => Optional[String[1]],
  parsehostname => Optional[Enum['on', 'off']],
}]
```

### <a name="Rsyslog--Inputs--Improg"></a>`Rsyslog::Inputs::Improg`

Data type for Rsyslog Input module input parameters for Program input

Alias of

```puppet
Struct[{
  binary           => String[1],
  tag              => String[1],
  facility         => Optional[Stdlib::Syslogfacility],
  severity         => Optional[Rsyslog::Syslog::Severity],
  confirmmessages  => Optional[Enum['on', 'off']],
  signalonclose    => Optional[Enum['on', 'off']],
  closetimeout     => Optional[Integer],
  killunresponsive => Optional[Enum['on', 'off']],
}]
```

### <a name="Rsyslog--Inputs--Imptcp"></a>`Rsyslog::Inputs::Imptcp`

Data type for Rsyslog Plain TCP input module

Alias of

```puppet
Struct[{
  port                       => Optional[Stdlib::Port],
  path                       => Optional[Stdlib::Absolutepath],
  discardtruncatedmsg        => Optional[Enum['on', 'off']],
  fileowner                  => Optional[String[1]],
  fileownernum               => Optional[Integer],
  filegroup                  => Optional[String[1]],
  filegroupnum               => Optional[Integer],
  filecreatemode             => Optional[Stdlib::Filemode],
  failonchownfailure         => Optional[Enum['on', 'off']],
  unlink                     => Optional[Enum['on', 'off']],
  name                       => Optional[String[1]],
  ruleset                    => Optional[String[1]],
  maxframesize               => Optional[Integer],
  address                    => Optional[Stdlib::IP::Address::V4],
  addtlframedelimiter        => Optional[Integer],
  supportoctetcountetframing => Optional[Enum['on', 'off']],
  notifyonconnectionclose    => Optional[Enum['on', 'off']],
  notifyonconnectionopen     => Optional[Enum['on', 'off']],
  keepalive                  => Optional[Enum['on', 'off']],
  'keepalive.probes'         => Optional[Integer],
  'keepalive.interval'       => Optional[Integer],
  'keepalive.time'           => Optional[Integer],
  'ratelimit.interval'       => Optional[Integer],
  'ratelimit.burst'          => Optional[Integer],
  'compression.mode'         => Optional[Enum['none', 'single', 'stream:always']],
  flowcontrol                => Optional[Enum['on', 'off']],
  multiline                  => Optional[Enum['on', 'off']],
  'framing.delimiter.regex'  => Optional[String[1]],
  socketbacklog              => Optional[Integer],
  defaulttz                  => Optional[String[1]],
  'framingfix.cisco.asa'     => Optional[Enum['on', 'off']],
  listenportfilename         => Optional[String[1]],
}]
```

### <a name="Rsyslog--Inputs--Imrelp"></a>`Rsyslog::Inputs::Imrelp`

Data type for Rsyslog Plain TCP input module

Alias of

```puppet
Struct[{
  port                 => Stdlib::Port,
  address              => Optional[Stdlib::IP::Address::V4],
  name                 => Optional[String[1]],
  ruleset              => Optional[String[1]],
  maxdatasize          => Optional[Pattern[/^([0-9]+)[kKmMgGtT]$/]],
  tls                  => Optional[Enum['on', 'off']],
  'tls.compression'    => Optional[Enum['on', 'off']],
  'tls.dhbits'         => Optional[Integer],
  'tls.permittedpeer'  => Optional[Array[String[1]]],
  'tls.authmode'       => Optional[Enum['fingerprint', 'name']],
  'tls.cacert'         => Optional[String[1]],
  'tls.mycert'         => Optional[String[1]],
  'tls.myprivkey'      => Optional[String[1]],
  'tls.prioritystring'  => Optional[String[1]],
  keepalive            => Optional[Enum['on', 'off']],
  'keepalive.probes'   => Optional[Integer],
  'keepalive.interval' => Optional[Integer],
  'keepalive.time'     => Optional[Integer],
  oversizemode         => Optional[Enum['truncate', 'abort', 'accept']],
}]
```

### <a name="Rsyslog--Inputs--Imtcp"></a>`Rsyslog::Inputs::Imtcp`

Data type for Rsyslog TCP input module

Alias of

```puppet
Struct[{
  port                       => Stdlib::Port,
  address                    => Optional[Stdlib::IP::Address::V4],
  name                       => Optional[String[1]],
  ruleset                    => Optional[String[1]],
  supportoctetcountedframing => Optional[Enum['on', 'off']],
  'ratelimit.interval'       => Optional[Integer],
  'ratelimit.burst'          => Optional[Integer],
  listenportfilename         => Optional[String[1]],
}]
```

### <a name="Rsyslog--Inputs--Imtuxedoulog"></a>`Rsyslog::Inputs::Imtuxedoulog`

Data for Rsyslog Input Tuxedo ULOG module

Alias of

```puppet
Struct[{
  ulogbase             => Stdlib::Absolutepath,
  tag                  => String[1],
  facility             => Optional[Stdlib::Syslogfacility],
  severity             => Optional[Rsyslog::Syslog::Severity],
  persiststateinterval => Optional[Integer],
  maxlinesatonce       => Optional[Integer],
  maxsubmitatonce      => Optional[Integer],
}]
```

### <a name="Rsyslog--Inputs--Imudp"></a>`Rsyslog::Inputs::Imudp`

Data type for Rsyslog UDP input module

Alias of

```puppet
Struct[{
  address              => Optional[Stdlib::Host],
  port                 => Stdlib::Port,
  ipfreebind           => Optional[Integer[0,2]],
  device               => Optional[String[1]],
  ruleset              => Optional[String[1]],
  'ratelimit.interval' => Optional[Integer],
  'ratelimit.burst'    => Optional[Integer],
  name                 => Optional[String[1]],
  'name.appendport'    => Optional[Enum['on', 'off']],
  defaulttz            => Optional[String[1]],
  rcvbufsize           => Optional[Variant[Integer, String[1]]],
}]
```

### <a name="Rsyslog--Inputs--Imuxsock"></a>`Rsyslog::Inputs::Imuxsock`

Data type for Rsyslog Unix Socket input module

Alias of

```puppet
Struct[{
  ruleset              => Optional[String[1]],
  ignoretimestamp      => Optional[Enum['on', 'off']],
  ignoreownmessages    => Optional[Enum['on', 'off']],
  flowcontrol          => Optional[Enum['on', 'off']],
  'ratelimit.interval' => Optional[Integer],
  'ratelimit.burst'    => Optional[Integer],
  'ratelimit.severity' => Optional[Integer[0,7]],
  usepidfromsystem     => Optional[Enum['on', 'off']],
  usesystimestamp      => Optional[Enum['on', 'off']],
  createpath           => Optional[Enum['on', 'off']],
  socket               => Optional[String[1]],
  hostname             => Optional[String[1]],
  annotate             => Optional[Enum['on', 'off']],
  parsetrusted         => Optional[Enum['on', 'off']],
  unlink               => Optional[Enum['on', 'off']],
  usespecialparser     => Optional[Enum['on', 'off']],
  parsehostname        => Optional[Enum['on', 'off']],
}]
```

### <a name="Rsyslog--Modules--Input"></a>`Rsyslog::Modules::Input`

The Rsyslog::Modules::Input data type.

Alias of `Enum['im3195', 'imfile', 'imgssapi', 'imjournal', 'imkafka', 'imklog', 'imkmsg', 'immark', 'impstats', 'imptcp', 'imrelp', 'imsolaris', 'imtcp', 'imupd', 'imuxsock']`

### <a name="Rsyslog--Modules--Inputs--Imdocker"></a>`Rsyslog::Modules::Inputs::Imdocker`

Data type for Rsyslog module parameters for imdocker

Alias of

```puppet
Struct[{
  dockerapiunixsockaddr    => Optional[Stdlib::Absolutepath],
  apiversionstr            => Optional[Pattern[/^v([0-9]+)\.([0-9]+)/]],
  pollinginterval          => Optional[Integer],
  listcontaineroptions     => Optional[String[1]],
  getcontainerlogoptions   => Optional[String[1]],
  retrievenewlogsfromstart => Optional[Integer[0,1]],
  defaultfacility          => Optional[Stdlib::Syslogfacility],
  defaultseverity          => Optional[Rsyslog::Syslog::Severity],
  escapelf                 => Optional[Enum['on', 'off']],
}]
```

### <a name="Rsyslog--Modules--Inputs--Imfile"></a>`Rsyslog::Modules::Inputs::Imfile`

Data type for Rsyslog Input module parameters for file inputs.

Alias of

```puppet
Struct[{
  mode               => Optional[Enum['inotify', 'polling']],
  readtimeout        => Optional[Integer],
  timeoutgranularity => Optional[Enum['on', 'off']],
  sortfiles          => Optional[Enum['on', 'off']],
  pollinginterval    => Optional[Integer],
}]
```

### <a name="Rsyslog--Modules--Inputs--Imjournal"></a>`Rsyslog::Modules::Inputs::Imjournal`

Rsyslog imjournal Module parameter data type

Alias of

```puppet
Struct[{
  persiststateinterval    => Optional[Integer],
  statefile               => Optional[Stdlib::Absolutepath],
  'ratelimit.interval'    => Optional[Integer],
  'ratelimit.burst'       => Optional[Integer],
  ignorepreviousmessage   => Optional[Enum['on', 'off']],
  defaultseverity         => Optional[Rsyslog::Syslog::Severity],
  defaultfacility         => Optional[Stdlib::Syslogfacility],
  usepidfromsystem        => Optional[Enum['on', 'off']],
  usepid                  => Optional[Enum['syslog', 'system', 'both']],
  ignorenonvalidstatefile => Optional[Enum['on', 'off']],
  workaroundjournalbug    => Optional[Enum['on', 'off']],
}]
```

### <a name="Rsyslog--Modules--Message"></a>`Rsyslog::Modules::Message`

The Rsyslog::Modules::Message data type.

Alias of `Enum['mmanon', 'mmcount', 'mmdblookup', 'mmexternal', 'mmfields', 'mmjsonparse', 'mmkubernetes', 'mmnormalize', 'mmpstructdata', 'mmrfc5424addhmac', 'mmrm1stspace', 'mmsequence', 'mmsnmptrapd', 'mmutf8fix']`

### <a name="Rsyslog--Modules--Output"></a>`Rsyslog::Modules::Output`

The Rsyslog::Modules::Output data type.

Alias of `Enum['omamqp1', 'omelasticsearch', 'omfile', 'omfwd', 'omhdfs', 'omhiredis', 'omhttpfs', 'omjournal', 'omkafka', 'omlibdbi', 'ommail', 'ommongodb', 'ommysql', 'ompgsql', 'ompipe', 'omprog', 'omrelp', 'omsnmp', 'omudpspoof', 'omusrmsg', 'omuxsock']`

### <a name="Rsyslog--Modules--Parser"></a>`Rsyslog::Modules::Parser`

The Rsyslog::Modules::Parser data type.

Alias of `Enum['pmciscoios', 'pmlastmsg', 'pmnormalize', 'pmnull', 'pmrfc3164', 'pmrfc3164sd', 'pmrfc5424']`

### <a name="Rsyslog--Modules--String"></a>`Rsyslog::Modules::String`

The Rsyslog::Modules::String data type.

Alias of `Enum['smfile', 'smfwd', 'smtradfile', 'smtradfwd']`

### <a name="Rsyslog--PropertyOperator"></a>`Rsyslog::PropertyOperator`

Enumerable custom type for rsyslog property operators

Alias of `Enum['contains', 'isequal', 'startswith', 'regex', 'ereregex', '!contains', '!isequal', '!startswith', '!regex', '!ereregex']`

### <a name="Rsyslog--Queue--Parameters"></a>`Rsyslog::Queue::Parameters`

The Rsyslog::Queue::Parameters data type.

Alias of

```puppet
Struct[{
  'queue.filename'                    => Optional[String[1]],
  'queue.spoolDirectory'              => Optional[Stdlib::Absolutepath],
  'queue.size'                        => Optional[Integer],
  'queue.dequeueBatchSize'            => Optional[Integer],
  'queue.maxDiskSpace'                => Optional[Integer],
  'queue.highWatermark'               => Optional[Integer],
  'queue.lowWatermark'                => Optional[Integer],
  'queue.fullDelaymark'               => Optional[Integer],
  'queue.lightDelaymark'              => Optional[Integer],
  'queue.discardMark'                 => Optional[Integer],
  'queue.discardSeverity'             => Optional[Integer],
  'queue.checkpointInterval'          => Optional[Integer],
  'queue.syncqueuefiles'              => Optional[Enum['on', 'off']],
  'queue.samplingInterval'            => Optional[Integer],
  'queue.type'                        => Optional[Enum['FixedArray', 'LinkedList', 'Direct', 'Disk']],
  'queue.workerThreads'               => Optional[Integer],
  'queue.workerThreadMinimumMessages' => Optional[Integer],
  'queue.timeoutWorkerthreadShutdown' => Optional[Integer],
  'queue.timeoutshutdown'             => Optional[Integer],
  'queue.timeoutActionCompletion'     => Optional[Integer],
  'queue.timeoutEnqueue'              => Optional[Integer],
  'queue.maxFileSize'                 => Optional[Pattern[/^([0-9]+)(m|M|g|G)$/]],
  'queue.saveOnShutdown'              => Optional[Enum['on', 'off']],
  'queue.dequeueSlowDown'             => Optional[Integer],
  'queue.dequeueTimeBegin'            => Optional[Integer[1, 24]],
  'queue.dequeueTimeEnd'              => Optional[Integer[1, 25]],
}]
```

### <a name="Rsyslog--Syslog--Severity"></a>`Rsyslog::Syslog::Severity`

Syslog severity data type

Alias of

```puppet
Variant[Enum[
    'emerg',
    'alert',
    'crit',
    'err',
    'warning',
    'notice',
    'info',
    'debug',
  ], Integer[0, 7]]
```

